import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { MonitorContactGroup } from '../models/index' 
/**
 * @author auto generate
 * @version 1.0
 * @date 2021-09-15 13:26
 */
interface MonitorContactGroupCU extends ConditionUtil<MonitorContactGroupCU>{
    ID:FieldUtil<MonitorContactGroupCU>;
    GROUP_NAME:FieldUtil<MonitorContactGroupCU>;
    REMARK:FieldUtil<MonitorContactGroupCU>;
    DELETED:FieldUtil<MonitorContactGroupCU>;
    CREATE_TIME:FieldUtil<MonitorContactGroupCU>;
    UPDATE_TIME:FieldUtil<MonitorContactGroupCU>;
}

class MonitorContactGroupCUImpl extends ConditionUtilImpl<MonitorContactGroupCUImpl> implements MonitorContactGroupCU{ 
    newInstance(): MonitorContactGroupCUImpl {
        return new MonitorContactGroupCUImpl();
    } 
    get ID(): FieldUtil<MonitorContactGroupCU>{  
        return new FieldUtil('id','id','主键', this);
    }
    get GROUP_NAME(): FieldUtil<MonitorContactGroupCU>{  
        return new FieldUtil('group_name','groupName','分组名', this);
    }
    get REMARK(): FieldUtil<MonitorContactGroupCU>{  
        return new FieldUtil('remark','remark','备注', this);
    }
    get DELETED(): FieldUtil<MonitorContactGroupCU>{  
        return new FieldUtil('deleted','deleted','deleted', this);
    }
    get CREATE_TIME(): FieldUtil<MonitorContactGroupCU>{  
        return new FieldUtil('create_time','createTime','create_time', this);
    }
    get UPDATE_TIME(): FieldUtil<MonitorContactGroupCU>{  
        return new FieldUtil('update_time','updateTime','update_time', this);
    }
}

@Singleton 
class MonitorContactGroupMU extends TableUtilImpl<MonitorContactGroupCU,MonitorContactGroup>{ 
    tableName  = 'monitor_contact_group';
    tableFields  = ['id','group_name','remark','deleted','create_time','update_time'];
    modelFields  = ['id','groupName','remark','deleted','createTime','updateTime'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): MonitorContactGroupCU {
        return new MonitorContactGroupCUImpl();
    }   

    static get ID(): FieldUtil<MonitorContactGroupCU>{ 
        return new FieldUtil('id','id','主键', new MonitorContactGroupCUImpl());
    }
    static get GROUP_NAME(): FieldUtil<MonitorContactGroupCU>{ 
        return new FieldUtil('group_name','groupName','分组名', new MonitorContactGroupCUImpl());
    }
    static get REMARK(): FieldUtil<MonitorContactGroupCU>{ 
        return new FieldUtil('remark','remark','备注', new MonitorContactGroupCUImpl());
    }
    static get DELETED(): FieldUtil<MonitorContactGroupCU>{ 
        return new FieldUtil('deleted','deleted','deleted', new MonitorContactGroupCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<MonitorContactGroupCU>{ 
        return new FieldUtil('create_time','createTime','create_time', new MonitorContactGroupCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<MonitorContactGroupCU>{ 
        return new FieldUtil('update_time','updateTime','update_time', new MonitorContactGroupCUImpl());
    }

    get ID(): FieldUtil<MonitorContactGroupCU>{ 
        return MonitorContactGroupMU.ID;
    }
    get GROUP_NAME(): FieldUtil<MonitorContactGroupCU>{ 
        return MonitorContactGroupMU.GROUP_NAME;
    }
    get REMARK(): FieldUtil<MonitorContactGroupCU>{ 
        return MonitorContactGroupMU.REMARK;
    }
    get DELETED(): FieldUtil<MonitorContactGroupCU>{ 
        return MonitorContactGroupMU.DELETED;
    }
    get CREATE_TIME(): FieldUtil<MonitorContactGroupCU>{ 
        return MonitorContactGroupMU.CREATE_TIME;
    }
    get UPDATE_TIME(): FieldUtil<MonitorContactGroupCU>{ 
        return MonitorContactGroupMU.UPDATE_TIME;
    }
}
export {MonitorContactGroupMU, MonitorContactGroupCU}
